//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%399428BF0380.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%399428BF0380.cm

//## begin module%399428BF0380.cp preserve=no
//## end module%399428BF0380.cp

//## Module: XspecRegistry%399428BF0380; Package body
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/DataFactory/XspecRegistry.cxx

//## begin module%399428BF0380.additionalIncludes preserve=no
//## end module%399428BF0380.additionalIncludes

//## begin module%399428BF0380.includes preserve=yes
#include <XSstreams.h>
#include <XSUtil/Utils/XSstream.h>
//## end module%399428BF0380.includes

// DataFactory
#include <XSModel/DataFactory/DataFactory.h>
// Error
#include <XSUtil/Error/Error.h>
// typeinfo
#include <typeinfo>
// SfData
#include <XSModel/Data/SfData.h>
// EinsteinData
#include <XSModel/Data/EinsteinData.h>
// OGIP-92aData
#include <XSModel/Data/OGIP-92aData.h>
// SfBackground
#include <XSModel/Data/BackCorr/SfBackground.h>
// EinsteinBackground
#include <XSModel/Data/BackCorr/EinsteinBackground.h>
// OGIP-92aBackground
#include <XSModel/Data/BackCorr/OGIP-92aBackground.h>
// EinsteinResponse
#include <XSModel/Data/Detector/EinsteinResponse.h>
// SfResponse
#include <XSModel/Data/Detector/SfResponse.h>
// OGIP-92aResponse
#include <XSModel/Data/Detector/OGIP-92aResponse.h>
// XspecRegistry
#include <XSModel/DataFactory/XspecRegistry.h>


//## begin module%399428BF0380.declarations preserve=no
//## end module%399428BF0380.declarations

//## begin module%399428BF0380.additionalDeclarations preserve=yes
//## end module%399428BF0380.additionalDeclarations


// Class XspecRegistry::UnrecognizedFormat 

XspecRegistry::UnrecognizedFormat::UnrecognizedFormat (const string& msg)
  //## begin XspecRegistry::UnrecognizedFormat::UnrecognizedFormat%39FF34670389.hasinit preserve=yes
  : YellowAlert(string("file format not recognized: input file "))  
  //## end XspecRegistry::UnrecognizedFormat::UnrecognizedFormat%39FF34670389.hasinit
  //## begin XspecRegistry::UnrecognizedFormat::UnrecognizedFormat%39FF34670389.initialization preserve=yes
  //## end XspecRegistry::UnrecognizedFormat::UnrecognizedFormat%39FF34670389.initialization
{
  //## begin XspecRegistry::UnrecognizedFormat::UnrecognizedFormat%39FF34670389.body preserve=yes
 tcerr << msg << std::endl; 
  //## end XspecRegistry::UnrecognizedFormat::UnrecognizedFormat%39FF34670389.body
}


// Class XspecRegistry 

//## begin XspecRegistry::instance%39DA245C0015.attr preserve=no  private: static XspecRegistry* {U} 0
XspecRegistry* XspecRegistry::s_instance = 0;
//## end XspecRegistry::instance%39DA245C0015.attr

XspecRegistry::XspecRegistry()
  //## begin XspecRegistry::XspecRegistry%399427D601CA_const.hasinit preserve=no
  //## end XspecRegistry::XspecRegistry%399427D601CA_const.hasinit
  //## begin XspecRegistry::XspecRegistry%399427D601CA_const.initialization preserve=yes
  //## end XspecRegistry::XspecRegistry%399427D601CA_const.initialization
{
  //## begin XspecRegistry::XspecRegistry%399427D601CA_const.body preserve=yes
  registerNativeTypes();
  //## end XspecRegistry::XspecRegistry%399427D601CA_const.body
}


XspecRegistry::~XspecRegistry()
{
  //## begin XspecRegistry::~XspecRegistry%399427D601CA_dest.body preserve=yes
   std::map<const char*,DataPrototype*>::iterator itMap = m_dataFormats.begin();
   std::map<const char*,DataPrototype*>::iterator itMapEnd = m_dataFormats.end();
   while (itMap != itMapEnd)
   {
      delete itMap->second;
      ++itMap;
   }
  //## end XspecRegistry::~XspecRegistry%399427D601CA_dest.body
}



//## Other Operations (implementation)
void XspecRegistry::addToRegistry (DataFactory* factory)
{
  //## begin XspecRegistry::addToRegistry%399959F90242.body preserve=yes
        
        try
        {
                // can throw bad_cast.
                DataPrototype* proto = static_cast<DataPrototype*>(factory);
                dataFormats(typeid(*(proto->protoDataSet())).name(),proto);
        }
        catch (...)
        {
                // throw a YellowAlert here, to allow this to be caught by
                // calling routine.
                throw YellowAlert();       
        }
  //## end XspecRegistry::addToRegistry%399959F90242.body
}

void XspecRegistry::registerNativeTypes ()
{
  //## begin XspecRegistry::registerNativeTypes%39D9F2910153.body preserve=yes
  
  try
  {
        addToRegistry(new DataPrototype(new OGIP_92aData, new OGIP_92aResponse, 
                      new OGIP_92aBackground,new OGIP_92aCorrection));
    
      //  addToRegistry(new DataPrototype(new EinsteinData, new EinsteinResponse, 
     //                 new EinsteinBackground, new EinsteinCorrection));
 
     //   addToRegistry(new DataPrototype(new SfData, new SfResponse, 
     //                   new SfBackground,new SfCorrection));
   }
   catch (YellowAlert)
   {
         // if registering the native datatypes fails, terminate.  
         throw RedAlert("Error registering XSPEC data formats. Exiting");  
   }
  //## end XspecRegistry::registerNativeTypes%39D9F2910153.body
}

XspecRegistry* XspecRegistry::Instance ()
{
  if (s_instance == 0) {s_instance = new XspecRegistry;} return s_instance;

  //## begin XspecRegistry::Instance%39DA2461003B.body preserve=yes
  //## end XspecRegistry::Instance%39DA2461003B.body
}

DataPrototype* XspecRegistry::returnPrototype (const string& fileName, XspecDataIO::DataType type)
{
  //## begin XspecRegistry::returnPrototype%39ECB51000AF.body preserve=yes
  std::map<const char*, DataPrototype*>::const_iterator dp =     m_dataFormats.begin();
  std::map<const char*, DataPrototype*>::const_iterator endList = m_dataFormats.end();
  DataPrototype* test = 0;
  try
  {
     // Since it's OK to have mismatches before getting
     // the right dataset class type, turn off whatever error
     // output the various fileFormat functions may produce.
     XSstream::verbose(tperr,9999,9999);
     while (dp != endList)
     {
             test = dp->second;
             if (test->protoDataSet()->fileFormat(fileName, type)) break;
             ++dp;
     }
     XSstream::verbose(tperr);
  }
  catch (YellowAlert&)
  {
     XSstream::verbose(tperr);
     throw;
  }
  if ( dp == endList ) throw UnrecognizedFormat(fileName);
  
  return test;
  //## end XspecRegistry::returnPrototype%39ECB51000AF.body
}

DataPrototype* XspecRegistry::returnPrototype (const std::type_info& dataClass)
{
  //## begin XspecRegistry::returnPrototype%3E96F01B039F.body preserve=yes
  std::map<const char*, DataPrototype*>::const_iterator dp =     m_dataFormats.begin();
  std::map<const char*, DataPrototype*>::const_iterator endList = m_dataFormats.end();
  DataPrototype* test = 0;
  while (dp != endList)
  {
          test = dp->second;
	  if (typeid(*(test->protoDataSet())) == dataClass)  break;
          ++dp;
  }
  if ( dp == endList ) throw UnrecognizedFormat(dataClass.name());
  
  return test;
  //## end XspecRegistry::returnPrototype%3E96F01B039F.body
}

// Additional Declarations
  //## begin XspecRegistry%399427D601CA.declarations preserve=yes
  //## end XspecRegistry%399427D601CA.declarations

// Class RegisteredFormat 

RegisteredFormat::RegisteredFormat()
  //## begin RegisteredFormat::RegisteredFormat%3999454501BC_const.hasinit preserve=no
  //## end RegisteredFormat::RegisteredFormat%3999454501BC_const.hasinit
  //## begin RegisteredFormat::RegisteredFormat%3999454501BC_const.initialization preserve=yes
  //## end RegisteredFormat::RegisteredFormat%3999454501BC_const.initialization
{
  //## begin RegisteredFormat::RegisteredFormat%3999454501BC_const.body preserve=yes
  //## end RegisteredFormat::RegisteredFormat%3999454501BC_const.body
}



//## Other Operations (implementation)
bool RegisteredFormat::isRegistered (const XspecRegistry& registry) const
{
  //## begin RegisteredFormat::isRegistered%399967C6008E.body preserve=yes
  return true;
  //## end RegisteredFormat::isRegistered%399967C6008E.body
}

// Additional Declarations
  //## begin RegisteredFormat%3999454501BC.declarations preserve=yes
  //## end RegisteredFormat%3999454501BC.declarations

//## begin module%399428BF0380.epilog preserve=yes
RegisteredFormat::~RegisteredFormat() {}
//## end module%399428BF0380.epilog
